//----------------------------------------------------------------------//
// FFT																	//
//																		//
//----------------------------------------------------------------------//
#include "FFT.h"

//---------------------------------------------------------------------------
FFT::FFT()
{
	dcomplex arg;
	dcomplex uj(0,1);

	for (int i=0; i<SAMPLES; i++) hst_buf[i] = 0.0;
	hst_ptr = 0;

	//twiddle factor ̕\
	arg = -uj*(2.0*M_PI/SAMPLES);
	for (int i=0; i<SAMPLES/2; i++) w_tbl[i] = exp(arg*(dcomplex)i);

	//rbgt\
	int n_half = SAMPLES/2; b_tbl[0]=0;
	for (int ne=1; ne<SAMPLES; ne<<=1) {
		for (int jp=0; jp<ne; jp++) b_tbl[jp+ne] = b_tbl[jp]+n_half;
		n_half /= 2;
	}

	//njO֐쐬
	for (int i=0; i<SAMPLES; i++) hnw[i] = 0.5-0.5*cos(2.0*M_PI*i/SAMPLES);
}
//---------------------------------------------------------------------------
FFT::~FFT()
{
}

//---------------------------------------------------------------------------
// Ԃ̍XV
// rel:, img:
//---------------------------------------------------------------------------
void FFT::update(double rel, double img)
{
	hst_buf[hst_ptr] = dcomplex(rel,img);
    hst_ptr = (hst_ptr+1) % SAMPLES;

	for (int i=0; i<SAMPLES; i++) x[i] = hst_buf[(hst_ptr+i) % SAMPLES];

	for (int i=0;i<SAMPLES; i++) x[i] *= hnw[i];		//njO

	dcomplex xtmp;
	int n_half = SAMPLES/2;
	for (int ne=1; ne<SAMPLES; ne=ne*2) {
		int n_half2 = n_half*2;
		for (int jp=0; jp<SAMPLES; jp=jp+n_half2) {
			int jx = 0;
			for (int j=jp; j<jp+n_half; j++) {
				int jnh = j + n_half;
				xtmp   = x[j];
				x[j]   = xtmp + x[jnh];
				x[jnh] = (xtmp-x[jnh]) * w_tbl[jx];
				jx	   = jx + ne;
			}
		}
		n_half /= 2;
	}

	//rbgt̕בւ
	for (int i=0; i<SAMPLES; i++) {
		if (i<b_tbl[i]) {
			xtmp		= x[i];
			x[i]		= x[b_tbl[i]];
			x[b_tbl[i]] = xtmp;
		}
	}

	//p[
	for (int i=0; i<FFTOUT; i++) {
		mag[i] = abs(x[i+3]);
		pws[i] = norm(x[i+3]);
	}
}
//---------------------------------------------------------------------------
