//----------------------------------------------------------------------//
// Motion Harmony	CtH[										//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <Vcl.HtmlHelpViewer.hpp>
#include "usr_wic.h"
#include "Sensor.h"
#include "FFT.h"
#include "SndDlg.h"
#include "DsgnDlg.h"
#include "About.h"
#include "MainForm.h"

#pragma link "Vcl.HTMLHelpViewer"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TMotHarmoMainForm *MotHarmoMainForm;

Sensor	SS[2];
FFT		FF[2];

//---------------------------------------------------------------------------
//XP[\
const harmrec HarmoKeyTable[MAX_HARMTBL] = {
	{"Harmonic",
	  { 11, 15, 18, 22, 25, 29, 32, 36, 39, 43, 46, 50, 53, 57, 60, 64, 67, 71, 74, 88, 91, 95, 98,102}
	},
	{"Pentatonic",
	  { 31, 33, 36, 38, 40, 43, 45, 48, 50, 52, 55, 57, 60, 62, 64, 67, 69, 71, 74, 76, 79, 81, 84, 86}
	},
	{"Mistic",
	  {  5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 65, 70, 75, 80, 85, 90, 95,100,105,110,115,120}
	},
	{"Diminish",
	  { 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, 60, 63, 66, 69, 72, 75, 78, 81, 84, 87, 90, 93, 96}
	},
	{"Augment",
	  { 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96,100,104,108}
	}
};

//---------------------------------------------------------------------------
__fastcall TMotHarmoMainForm::TMotHarmoMainForm(TComponent* Owner)
		: TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::FormCreate(TObject *Sender)
{
	bgimg = new Graphics::TBitmap();

	DoubleBuffered = true;	//h~

	//wv̏
	Application->HelpFile = ChangeFileExt(Application->ExeName, ".CHM");

	//INIt@Cǂݍ
	IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
	UnicodeString sct = "General";

	int c_vno = 0;
	unsigned mj, mi, bl;
	if (GetProductVersion(Application->ExeName, mj, mi, bl)) c_vno = UnicodeString().sprintf(_T("%u%u%u"), mj,mi,bl).ToIntDef(0);

	int vno = IniFile->ReadInteger(sct,"Version",0);
	if (vno<c_vno) {
		IniFile->WriteInteger(sct,"Version", c_vno);	//o[WԍXV
	}
	sct = "Color";
	col_background = (TColor)IniFile->ReadInteger(sct,"background",	clNavy);
	col_pen 	   = (TColor)IniFile->ReadInteger(sct,"pen",		clYellow);
	col_brush	   = (TColor)IniFile->ReadInteger(sct,"brush",		clTeal);
	col_ring	   = (TColor)IniFile->ReadInteger(sct,"ring",		clSilver);
	Color		   = col_background;
	sct = "Sound";
	play_mode[0]   = IniFile->ReadInteger(sct,"PlayMode0",	1);
	play_mode[1]   = IniFile->ReadInteger(sct,"PlayMode1",	0);
	play_step[0]   = play_step[1]=0;
	scale_no	   = IniFile->ReadInteger(sct,"ScaleNo",	0);
	auto_scale	   = IniFile->ReadInteger(sct,"AutoScale",	1);
	pan_control    = IniFile->ReadInteger(sct,"PanControl",	0);
	volume		   = IniFile->ReadInteger(sct,"Volume",		90);

	// ȉ~Shape쐬
	TShape *sp;
	for (int i=0; i<24; i++) {
		sp				 = new TShape(MotHarmoMainForm);
		harmo_sp[i] 	 = sp;
		sp->Parent		 = MotHarmoMainForm;
		sp->Shape		 = stEllipse;
		sp->Width		 = 0;
		sp->Height		 = 0;
		sp->Left		 = 0;
		sp->Top 		 = 0;
		sp->Pen->Color	 = col_pen;
		sp->Brush->Color = col_brush;
		sp->Tag 		 = i;
	}
	//ւ쐬
	CtrlRing			   = new TShape(MotHarmoMainForm);
	CtrlRing->Parent	   = MotHarmoMainForm;
	CtrlRing->Shape 	   = stEllipse;
	CtrlRing->Pen->Color   = col_ring;
	CtrlRing->Brush->Style = bsClear;
    CtrlRing->Width 	   = 0;
    CtrlRing->Height	   = 0;

	//wi摜ݒ
	sct = "Design";
	enable_bgimg	= IniFile->ReadBool(sct,"EnableBgImage",	false);
	stretch_bgimg	= IniFile->ReadBool(sct,"StretchBgImage",	false);
	bgimg_file		= IniFile->ReadString(sct,"BgImage", 		EmptyStr);
	if (FileExists(bgimg_file))
		WIC_load_image(bgimg_file, bgimg);
	else
		bgimg_file = EmptyStr;

	hide_titlebar   = IniFile->ReadBool(sct,"HideTitlebar",		false);

	//Sensor 
  	//͂Ƀ}EXʒu蓖
    SS[0].lpSource = &mouseX;
    SS[1].lpSource = &mouseY;
	//tB^[̐ݒ (Tv64ŕω)
	SS[0].ini_filter(0, 64);
	SS[1].ini_filter(0, 64);

	//MIDI 
	sct = "Sound";
	MidiPort = new TMidiPort();
	MidiPort->DevNum = IniFile->ReadInteger(sct,"Driver",0);
	MidiPort->OutOpen();
	//ʂݒ
	for (int i=0; i<MAX_MIDICHN; i++) MidiPort->SetVolume(i, volume);
	//Fݒ
	MidiPort->SetPrg(0, IniFile->ReadInteger(sct,"Prg_00",92)-1);
	MidiPort->SetPrg(1, IniFile->ReadInteger(sct,"Prg_01",98)-1);
	for (int i=2; i<MAX_MIDICHN; i++) {
		UnicodeString kstr; kstr.sprintf(_T("prg_%02x"), i);
		MidiPort->SetPrg(i, IniFile->ReadInteger("Sound", kstr, 1)-1);
	}

	loop_count		= 0;
	Timer1->Enabled = true;
}

//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::FormShow(TObject *Sender)
{
	UnicodeString sct = "General";
	WindowState = (TWindowState)IniFile->ReadInteger(sct,"WinState",wsNormal);
	Width  = IniFile->ReadInteger(sct,"WinWidth", 640);
	Height = IniFile->ReadInteger(sct,"WinHeight",480);
	Left   = IniFile->ReadInteger(sct,"WinLeft",(Screen->Width-MotHarmoMainForm->Width)/2);
	Top    = IniFile->ReadInteger(sct,"WinTop", (Screen->Height-MotHarmoMainForm->Height)/2);
	SoundDlg->Left	= IniFile->ReadInteger(sct,"SoundDlgLeft",Left+50);
	SoundDlg->Top	= IniFile->ReadInteger(sct,"SoundDlgTop", Top+50);
	DesignDlg->Left = IniFile->ReadInteger(sct,"DesignDlgLeft",Left+100);
	DesignDlg->Top	= IniFile->ReadInteger(sct,"DesignDlgTop", Top+100);

    //ZT[̃WʃTCYɐݒ
	SS[0].SetRange(0, ClientWidth);
	SS[1].SetRange(0, ClientHeight);
}

//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	Timer1->Enabled = false;

	//ݒۑ
	UnicodeString sct ="General";
	IniFile->WriteInteger(sct,"WinState", WindowState);
	IniFile->WriteInteger(sct,"WinTop",	  Top);
	IniFile->WriteInteger(sct,"WinLeft",  Left);
	IniFile->WriteInteger(sct,"WinWidth", Width);
	IniFile->WriteInteger(sct,"WinHeight",Height);

	IniFile->WriteInteger(sct,"SoundDlgLeft", SoundDlg->Left);
	IniFile->WriteInteger(sct,"SoundDlgTop",  SoundDlg->Top);
	IniFile->WriteInteger(sct,"DesignDlgLeft",DesignDlg->Left);
	IniFile->WriteInteger(sct,"DesignDlgTop", DesignDlg->Top);

	sct = "Color";
	IniFile->WriteInteger(sct,"background", col_background);
	IniFile->WriteInteger(sct,"pen",        col_pen);
	IniFile->WriteInteger(sct,"brush",      col_brush);
	IniFile->WriteInteger(sct,"ring",       col_ring);

	sct = "Design";
    IniFile->WriteString(sct, "BgImage",		bgimg_file);
	IniFile->WriteBool(sct,"EnableBgImage",		enable_bgimg);
	IniFile->WriteBool(sct,"StretchBgImage",	stretch_bgimg);
	IniFile->WriteBool(sct,"HideTitlebar",		hide_titlebar);

	sct = "Sound";
	IniFile->WriteInteger(sct, "Driver", MidiPort->DevNum);
	for (int i=0; i<MAX_MIDICHN; i++) {
		UnicodeString kstr; kstr.sprintf(_T("prg_%02x"), i);
		IniFile->WriteString(sct, kstr, MidiPort->ChnPrg[i]+1);
	}
	IniFile->WriteInteger(sct,"PlayMode0", play_mode[0]);
	IniFile->WriteInteger(sct,"PlayMode1", play_mode[1]);
	IniFile->WriteInteger(sct,"ScaleNo",   scale_no);
	IniFile->WriteInteger(sct,"AutoScale", auto_scale);
	IniFile->WriteInteger(sct,"PanControl",pan_control);
	IniFile->WriteInteger(sct,"Volume",	   volume);

	//MIDIfoCX
	MidiPort->OutClose();
}
//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::FormDestroy(TObject *Sender)
{
	delete MidiPort;
	delete IniFile;
    delete bgimg;
}

//---------------------------------------------------------------------------
// ʔwi̕`
void __fastcall TMotHarmoMainForm::FormPaint(TObject *Sender)
{
	if (enable_bgimg) {
		try {
			if (!bgimg->Empty) {
				if (stretch_bgimg) {
					//O`ɍ킹
					Canvas->StretchDraw(ClientRect, bgimg);
				}
				else {
					//ׂĕ~l߂
					for(int x=0; x<ClientWidth; x+=bgimg->Width) {
						for(int y=0; y<ClientHeight; y+=bgimg->Height) {
							Canvas->Draw(x,y, bgimg);
						}
					}
				}
			}
        }
		catch(...) {
			enable_bgimg = false;
		}
	}
}
//---------------------------------------------------------------------
// ő剻␳(^Cgo[ƃj[B)
void __fastcall TMotHarmoMainForm::WmGetMinMaxInfo(TWMGetMinMaxInfo &Msg ){
	TForm::Dispatch(&Msg);
	if (hide_titlebar) {
		RECT rc;
		::GetWindowRect(GetDesktopWindow(),&rc);
		::AdjustWindowRect(&rc, WS_OVERLAPPEDWINDOW, TRUE);
		Msg.MinMaxInfo->ptMaxSize.y		 = rc.bottom-rc.top;
		Msg.MinMaxInfo->ptMaxTrackSize.y = rc.bottom-rc.top;
		Msg.MinMaxInfo->ptMaxPosition.y	 = rc.top;
	}
}

//---------------------------------------------------------------------------
// Timer 
//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::Timer1Timer(TObject *Sender)
{
	loop_count++;

	//ZT[̍XV
	SS[0].update();
	SS[1].update();

	//XP[ݒ
	int scn;
	if (auto_scale) {
		double z = SS[1].get_valueUF(0);
		if		(z>0.85) scn = 3;		// Diminish
	    else if (z>0.7)  scn = 1;		// Pentatonic
		else if (z>0.5)  scn = 0;		// Harmonic
		else if (z>0.3)  scn = 1;		// Pentatonic
		else if (z>0.15) scn = 2;		// Mistic
		else 		     scn = 4;		// Augment
	}
	else {
		scn = scale_no;
	}

	//FFT vZ
	FF[0].update(SS[0].cur_value);
	FF[1].update(SS[1].cur_value);

	//
	double msum[2];
	double best4d[4];
	int    best4i[4];
	int i,j,bn,flag;
	int k,v,t;
	int tncnt,w,h,x,y;

	for (int sn=0;sn<2;sn++) {
        msum[sn] = 0;
		//4
		for (bn=0;bn<4;bn++) {
			best4d[bn] = 0.2;
			best4i[bn] = -1;
			for (i=0;i<FFTOUT;i++) {
				flag = 0;
				for (j=0;j<bn;j++) flag |= (i==best4i[j]);
				if (flag==0) {
					if (best4d[bn]<FF[sn].mag[i]) {
						best4d[bn] = FF[sn].mag[i];
						best4i[bn] = i;
					}
				}
			}
			if (best4d[bn]>2.0) best4d[bn] = 2.0;
			if (best4i[bn]!=-1) msum[sn] += best4d[bn];
		}
		msum[sn] /= 2;

		//`FbN
		flag  = 0;
		tncnt = 0;
		for (i=0;i<MAX_TONE;i++) {
			if (MidiPort->tone[i].flag==1) {
				for (bn=0;bn<4;bn++) {
					if (MidiPort->tone[i].ownr == VoiceTone+bn +sn*10) {
						flag |= (1<<bn);
						tncnt++;
					}
				}
			}
		}

		switch (play_mode[sn]) {
		case 0:	//m[}
			for (bn=0;bn<4;bn++) {
				if (((flag&(1<<bn))==0)&&(best4i[bn]!=-1)) {
					k = HarmoKeyTable[scn].key[best4i[bn]];
					v = floor(best4d[bn]*50);
					t = floor(best4d[bn]*16)+4;
					MidiPort->cre_ton(0+sn, k, v, t, VoiceTone+bn +sn*10);
				}
			} break;

		case 1:	//V[PV
			bn = play_step[sn];
			if (tncnt==0) {
				if (best4i[bn]!=-1) {
					k = HarmoKeyTable[scn].key[best4i[bn]];
					v = floor(best4d[bn]*50);
					t = 12-floor(best4d[bn]*4); if (t<=0) t=2;
					MidiPort->cre_ton(0+sn, k, v, t, VoiceTone+bn +sn*10);
				}
				play_step[sn] = (play_step[sn]+1)%4;
			}
			break;
		}

	}

	//p
	if (loop_count % 4==0) {
		if ((pan_control) && (tncnt>0)) {
			v = floor(SS[0].get_valueUF(0)*127);
			MidiPort->SetPan(0,v);
			MidiPort->SetPan(1,v);
		}
	}
	MidiPort->upd_ton();


	//ȉ~XV
	for (i=0;i<24;i++) {
		TShape *sp = harmo_sp[i];
		w  = floor(FF[0].mag[i]*ClientWidth/50)+4;
		h  = floor(FF[1].mag[i]*ClientWidth/50)+4;
		x  = ClientWidth/27*(i+2);
		y  = (ClientHeight-h)*7/8-(ClientHeight/30*i);
		sp->Left   = x;
		sp->Top    = y;
		sp->Width  = w;
		sp->Height = h;
	}

	//ւXV
	CtrlRing->Left	 = floor(ClientWidth*(0.5+SS[0].get_valueSF(0)*0.45));
	CtrlRing->Top	 = floor(ClientHeight*(0.5+SS[1].get_valueSF(0)*0.45));
	CtrlRing->Width  = floor(msum[0]*ClientWidth/50);
	CtrlRing->Height = floor(msum[1]*ClientWidth/50);
}


//---------------------------------------------------------------------------
// }EX
//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
	mouseX = X;
	mouseY = Y;
}


//---------------------------------------------------------------------------
// TCYύX
//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::FormResize(TObject *Sender)
{
	//ZT[̃WXV
	SS[0].SetRange(0, ClientWidth);
	SS[1].SetRange(0, ClientHeight);

	Repaint();
}


//---------------------------------------------------------------------------
// j[
//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::ExitItemClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::OptSoundItemClick(TObject *Sender)
{
	SoundDlg->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::OptDesignItemClick(TObject *Sender)
{
    DesignDlg->Show();
}

//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::HelpContentsItemClick(TObject *Sender)
{
	Application->HelpShowTableOfContents();
}
//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::HelpAboutItemClick(TObject *Sender)
{
	AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::PopRestoreItemClick(TObject *Sender)
{
	WindowState = wsNormal;
}
//---------------------------------------------------------------------------
void __fastcall TMotHarmoMainForm::PopupMenu1Popup(TObject *Sender)
{
	PopRestoreItem->Visible = (hide_titlebar && (WindowState==wsMaximized));
}
//---------------------------------------------------------------------------

