//----------------------------------------------------------------------//
// Motion Harmony	CtH[										//
//																		//
//----------------------------------------------------------------------//
#ifndef MainFormH
#define MainFormH

//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <System.IniFiles.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.Menus.hpp>
#include <Vcl.Buttons.hpp>
#include "MidiPort.h"

//---------------------------------------------------------------------------
#define MAX_HARMTBL 5

enum {VoiceTone = 0};

struct harmrec {
	char name[80];
	int  key[24];
};

extern const harmrec HarmoKeyTable[MAX_HARMTBL];

//---------------------------------------------------------------------------
class TMotHarmoMainForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TMainMenu *MainMenu1;
	TMenuItem *ExitItem;
	TMenuItem *File1;
	TMenuItem *Help1;
	TMenuItem *HelpAboutItem;
	TMenuItem *HelpContentsItem;
	TMenuItem *OptDesignItem;
	TMenuItem *Option1;
	TMenuItem *OptSoundItem;
	TMenuItem *PopDesignItem;
	TMenuItem *PopExitItem;
	TMenuItem *PopRestoreItem;
	TMenuItem *PopSoundItem;
	TMenuItem *Pop_s1;
	TPopupMenu *PopupMenu1;
	TTimer *Timer1;

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall ExitItemClick(TObject *Sender);
	void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall OptSoundItemClick(TObject *Sender);
	void __fastcall OptDesignItemClick(TObject *Sender);
	void __fastcall HelpContentsItemClick(TObject *Sender);
	void __fastcall HelpAboutItemClick(TObject *Sender);
	void __fastcall PopRestoreItemClick(TObject *Sender);
	void __fastcall PopupMenu1Popup(TObject *Sender);

private:	// [U[錾
	void __fastcall WmGetMinMaxInfo(TWMGetMinMaxInfo &Msg);

public:		// [U[錾
	TIniFile  *IniFile;

	TShape* harmo_sp[24];
	TShape* CtrlRing;

	int mouseX,mouseY;
	int loop_count;

	int play_mode[2];
	int play_step[2];
	int pan_control;
	int auto_scale;
	int scale_no;
	int volume;

	TColor col_background;
	TColor col_pen;
	TColor col_brush;
	TColor col_ring;

	Graphics::TBitmap *bgimg; 	//wiC[W
	UnicodeString bgimg_file;
	bool enable_bgimg;
	bool stretch_bgimg;

	bool hide_titlebar;

	__fastcall TMotHarmoMainForm(TComponent* Owner);

	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_GETMINMAXINFO,TWMGetMinMaxInfo,WmGetMinMaxInfo)
	END_MESSAGE_MAP(TForm);
};
//---------------------------------------------------------------------------
extern PACKAGE TMotHarmoMainForm *MotHarmoMainForm;
//---------------------------------------------------------------------------
#endif
