//----------------------------------------------------------------------//
// Motion Harmony														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
USEFORM("About.cpp", AboutBox);
USEFORM("DsgnDlg.cpp", DesignDlg);
USEFORM("SndDlg.cpp", SoundDlg);
USEFORM("MainForm.cpp", MotHarmoMainForm);
//---------------------------------------------------------------------------
WINAPI _tWinMain(HINSTANCE, HINSTANCE, LPTSTR, int)
{
	//~[ebNXɂdNh~
	HANDLE hMutex = ::CreateMutex(NULL,FALSE, _T("MotionHarmony_is_running"));
	if (::GetLastError()==ERROR_ALREADY_EXISTS) {
		::CloseHandle(hMutex);
		return -1;
	}

	try
	{
		Application->Initialize();
		Application->Title = "Motion Harmony";
		Application->CreateForm(__classid(TMotHarmoMainForm), &MotHarmoMainForm);
		Application->CreateForm(__classid(TSoundDlg), &SoundDlg);
		Application->CreateForm(__classid(TDesignDlg), &DesignDlg);
		Application->CreateForm(__classid(TAboutBox), &AboutBox);
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}

	::CloseHandle(hMutex);
	return 0;
}
//---------------------------------------------------------------------------
