//----------------------------------------------------------------------//
// Motion Harmony	TEhݒ_CAO{bNX						//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include "MainForm.h"
#include "SndDlg.h"

//---------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSoundDlg *SoundDlg;

//---------------------------------------------------------------------
__fastcall TSoundDlg::TSoundDlg(TComponent* AOwner) : TForm(AOwner)
{
	MIDIOUTCAPS mcp;

	for (int i=0;i<MidiPort->GetDevMax();i++) {
		if (::midiOutGetDevCaps(i,&mcp,sizeof(mcp))==MMSYSERR_NOERROR)
			MidiOutDevCombo->Items->Add(mcp.szPname);
		else
			MidiOutDevCombo->Items->Add("<none>");
	}
	for (int i=0;i<128;i++) {
        ComboBox2->Items->Add(GM_Instrument[i]);
        ComboBox3->Items->Add(GM_Instrument[i]);
	}

	for (int i=0;i<MAX_HARMTBL;i++) {
		ScaleCombo->Items->Add(HarmoKeyTable[i].name);
	}
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::FormShow(TObject *Sender)
{
	MidiOutDevCombo->ItemIndex = MidiPort->DevNum;
	ComboBox2->ItemIndex  = MidiPort->ChnPrg[0];
	ComboBox3->ItemIndex  = MidiPort->ChnPrg[1];
	SeqCheck1->Checked	  = (MotHarmoMainForm->play_mode[0]==1);
	SeqCheck2->Checked	  = (MotHarmoMainForm->play_mode[1]==1);
	ScaleCombo->ItemIndex = MotHarmoMainForm->scale_no;
	PanCtlCheck->Checked  = (MotHarmoMainForm->pan_control!=0);
	AutoCheck->Checked	  = (MotHarmoMainForm->auto_scale!=0);
	ScaleCombo->Enabled   = !AutoCheck->Checked;
	VolumeLabel->Caption  = MotHarmoMainForm->volume;
	TrackBar1->Position   = MotHarmoMainForm->volume;
}


//---------------------------------------------------------------------------
//foCXύX
void __fastcall TSoundDlg::MidiOutDevComboChange(TObject *Sender)
{
	MidiPort->OutClose();
	MidiPort->DevNum = MidiOutDevCombo->ItemIndex;
	MidiPort->OutOpen();
	//Đݒ
	for (int i=0;i<MAX_MIDICHN;i++) {
		MidiPort->SetVolume(i, MotHarmoMainForm->volume);
		MidiPort->SetPrg(i, MidiPort->ChnPrg[i]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::PrgChgChange(TObject *Sender)
{
	TComboBox *p = (TComboBox*)Sender;
	MidiPort->SetPrg(p->Tag, p->ItemIndex);
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::ScaleChange(TObject *Sender)
{
	TComboBox* p	= (TComboBox*)Sender;
    MotHarmoMainForm->scale_no = p->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::SeqCheck1Click(TObject *Sender)
{
	if (SeqCheck1->Checked)
		MotHarmoMainForm->play_mode[0] = 1;
	else
		MotHarmoMainForm->play_mode[0] = 0;
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::SeqCheck2Click(TObject *Sender)
{
	if (SeqCheck2->Checked)
		MotHarmoMainForm->play_mode[1] = 1;
	else
		MotHarmoMainForm->play_mode[1] = 0;
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::PanCtlCheckClick(TObject *Sender)
{
    MotHarmoMainForm->pan_control = PanCtlCheck->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::AutoCheckClick(TObject *Sender)
{
    MotHarmoMainForm->auto_scale = AutoCheck->Checked;
    ScaleCombo->Enabled 		 = !AutoCheck->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TSoundDlg::TrackBar1Change(TObject *Sender)
{
	MotHarmoMainForm->volume = TrackBar1->Position;
    VolumeLabel->Caption	 = MotHarmoMainForm->volume;
	for (int i=0;i<MAX_MIDICHN;i++)
		MidiPort->SetVolume(i, MotHarmoMainForm->volume);
}
//---------------------------------------------------------------------------

